<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
* @version		$Id: html.php 434 2010-08-17 15:32:50Z stian $
* @category		Koowa
* @package      Koowa_Modules
* @copyright    Copyright (C) 2007 - 2009 Johan Janssens and Mathias Verraes. All rights reserved.
* @license      GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
* @link         http://www.koowa.org
*/

/**
 * ComNinjaViewModuleHtml
 *
 * Originally ModDefaultHtml, but we moved it here so that we don't have to install two dummy modules on our users sites.
 * It also allows us to make modules more easily do things that we do often @NinjaForge (like rendering modules within modules)
 * Not to forget have our standard view apis at hand :)
 * 
 * @author stian didriksen <stian@ninjaforge.com>
 */
class ComNinjaViewModuleHtml extends ComNinjaViewHtml
{
	/**
	 * Constructor
	 *
	 * @param	array An optional associative array of configuration settings.
	 */
	public function __construct(KConfig $options)
	{
        parent::__construct($options);
        
        // Initialize the options
		$options  = $this->_initialize($options);
        
		//Assign module specific options
        $this->params  = $options->params;
        $this->module  = $options->module;
        $this->attribs = $options->attribs;
        
        $template = KFactory::get('lib.koowa.application')->getTemplate();
        $path     = JPATH_THEMES.DS.$template.DS.'html'.DS.'mod_'.$this->_identifier->package;
          
		KFactory::get($this->getTemplate())->addPath($path);
	}
	
	/**
	 * Get the name
	 *
	 * Since module views have a shorter identifier string, we have to override this method.
	 *
	 * @return 	string 	The name of the object
	 */
	public function getName()
	{
		return $this->_identifier->package;
	}
	
	/**
	 * Initializes the options for the object
	 *
	 * Called from {@link __construct()} as a first step of object instantiation.
	 *
	 * @param   array   Options
	 * @return  array   Options
	 */
	protected function _initialize(KConfig $options)
	{
		$options->append(array(
            'params'  => null,
			'module'  => null,
			'attribs' => array(),
       	));
       	
        parent::_initialize($options);
    }
	
	/**
	 * Renders and echo's the views output
 	 *
	 * @return modDefaultHtml
	 */
	public function display()
	{
		//Render the template
		echo $this->loadTemplate();
		
		return $this;
	}
}