<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: default.php 754 2010-08-19 21:42:45Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

/**
 * Ninjaboard Default Controller
 *
 * @package Ninjaboard
 */
class ComNinjaboardControllerDefault extends ComNinjaControllerView
{
	/**
	 * Constructor
	 *
	 * @param 	object 	An optional KConfig object with configuration options
	 */
	public function __construct(KConfig $config)
	{
		parent::__construct($config);
		
		$cache = JPATH_ROOT.'/cache/com_'.$this->getIdentifier()->package . '/maintenance.forums.txt';

		if(!JFile::exists($cache))
		{
			KFactory::get('admin::com.ninjaboard.controller.maintenance')->forums();
			JFile::write($cache, date('r'));
		}
	}

	public function setTitle()
	{
		$title = KRequest::get('post.title', 'string', 'Untitled');
		$id	   = KRequest::get('get.id', 'int', 0);
		
		$table		= KFactory::get(KFactory::get($this->getModel())->getTable());
		$primaryKey	= current($table->getPrimaryKey())->name;
		$query		= $table->getDatabase()->getQuery()->where('title', '=', $title)->where($primaryKey, '!=', $id);

		if($table->count($query))
		{
			KRequest::set('post.title', $title . ' ' . JText::_('copy'), 'string');
			if((bool) $table->count($table->getDatabase()->getQuery()->where('title', '=', KRequest::get('post.title', 'string'))->where($primaryKey, '!=', $id))) self::setTitle();
		}
		
		return $this;
	}
	
	/**
	 * Generic function for setting the permissions
	 *
	 * @return void
	 */
	public function setPermissions()
	{
		$model 		= KFactory::get($this->getModel());
		$table		= KFactory::tmp(KFactory::get(KFactory::get('admin::com.ninja.helper.access')->models->assets)->getTable());
		$query		= $table->getDatabase()->getQuery();
		$item  		= $model->getItem();
		$identifier = $this->getIdentifier();
		$id			= $identifier->type.'_'.$identifier->package.'.'.$identifier->name.'.'.$item->id.'.';
		 
		$permissions = (array) KRequest::get('post.permissions', 'int');
		$editable	 = KRequest::get('post.editpermissions', 'boolean', false);
		
		if(!$permissions && $editable)
		{
			$query->where('tbl.name', 'LIKE', $id.'%');
			$table->select($query)->delete();
			return;
		}
		
		foreach($permissions as $name => $permission)
		{
			KFactory::tmp(KFactory::get('admin::com.ninja.helper.access')->models->assets)
				->name($id.$name)
				->getItem()
				->setData(array('name' => $id.$name, 'level' => $permission))
				->save();
		}	
	}
}