<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version $Id: forum.php 800 2010-08-31 20:10:31Z stian $
 * @package NinjaForge.Ninjaboard
 * @copyright Copyright (C) 2007-2010 Ninja Media Group. All rights reserved.
 * @license GNU/GPL. Please see license.php in Ninjaboard directory 
 * for copyright notices and details.
 * Ninjaboard is free software. This version may have been NOT modified.
 */

/**
 * Ninjaboard Forum Controller
 *
 * @package Ninjaboard
 */
class ComNinjaboardControllerForum extends ComNinjaboardControllerDefault
{
	/**
	 * Constructor
	 *
	 * @param 	object 	An optional KConfig object with configuration options
	 */
	public function __construct(KConfig $config)
	{
		parent::__construct($config);

		$this->registerFunctionAfter('add', 'setPermissions')
			 ->registerFunctionAfter('edit', 'setPermissions');

		KFactory::get('admin::com.ninjaboard.controller.maintenance')->forums();
	}

	/**
	 * Generic function for setting the permissions
	 *
	 * @return void
	 */
	public function setPermissions()
	{
		$model 		= KFactory::get($this->getModel());
		$table		= KFactory::tmp(KFactory::get(KFactory::get('admin::com.ninja.helper.access')->models->assets)->getTable());
		$query		= $table->getDatabase()->getQuery();
		$item  		= $model->getItem();
		$identifier = $this->getIdentifier();
		$id			= $identifier->type.'_'.$identifier->package.'.'.$identifier->name.'.'.$item->id.'.';
		 
		$permissions = (array) KRequest::get('post.permissions', 'int');
		$editable	 = KRequest::get('post.editpermissions', 'boolean', false);
		
		if(!$permissions && $editable)
		{
			$query->where('tbl.name', 'LIKE', $id.'%');
			$table->select($query)->delete();
			return;
		}
		
		foreach($permissions as $usergroup => $rules)
		{	
			foreach($rules as $name => $permission)
			{
				KFactory::tmp(KFactory::get('admin::com.ninja.helper.access')->models->assets)
					->name($id.$usergroup.'.'.$name)
					->getItem()
					->setData(array('name' => $id.$usergroup.'.'.$name, 'level' => $permission))
					->save();
			}
		}
	}

	/**
	 * Order action
	 *
	 * @TODO make use of sortables instead
	 */
	protected function _actionReorder($data)
	{
		die('<pre>'.var_export($data, true).'</pre>');
		$data['enabled'] = $this->getAction() == 'enable';

		return $this->execute('edit', $data);
	}
}