<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: tool.php 754 2010-08-19 21:42:45Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

/**
 * Ninjaboard Tools Controller
 *
 * @package Ninjaboard
 */
class ComNinjaboardControllerTool extends ComNinjaControllerView
{
	/**
	 * Constructor
	 *
	 * @param 	object 	An optional KConfig object with configuration options
	 */
	public function __construct(KConfig $config)
	{
		parent::__construct($config);

		$this->registerFunctionBefore('browse',	'raiseNotice');
		
		//If there's a shortcut, run the fireShortcut function
		if(isset($this->_request->shortcut)) $this->registerFunctionAfter('browse', 'fireShortcut');
		
		$cache = JPATH_ROOT.'/cache/com_'.$this->getIdentifier()->package . '/maintenance.forums.txt';
		
		if(JFile::exists($cache))
		{
			JFile::delete($cache);
		}
	}
	
	/**
	 * Fires an importer onload.
	 * Used by various help messages to improve the user experience
	 * by linking to import actions from any view.
	 *
	 * @author Stian Didriksen <stian@ninjaforge.com>
	 */
	public function fireShortcut()
	{
		$shortcut = $this->_request->shortcut;
		KFactory::get('lib.joomla.document')->addScriptDeclaration("
			window.addEvent('domready', function(){
				var button = document.getElement('.placeholder .$shortcut');
				if(button) {
					button.fireEvent('click', [], 1000);
				}
			});
		");
	}

	public function raiseNotice()
	{
		JError::raiseNotice(0, JText::_("Imported data will replace any existing data. Always remember to backup your site prior to imports."));
	}
	
	/*
	 * Generic import action
	 *
	 * @throws KControllerException
	 * @author Stian Didriksen <stian@ninjaforge.com>
	 */
	protected function _actionImport()
	{
		$converter = new KIdentifier('admin::com.ninjaboard.converter.default');
		$converter->name = KRequest::get('post.import', 'cmd', 'demo');
		
		$converter = KFactory::get($converter)->convert();

		if($converter->splittable && !KRequest::has('post.offset', 'int'))
		{
			KFactory::get('lib.koowa.application')->close();
			return;
		}
		
		if(KRequest::type() == 'AJAX')
		{
			/*
			$data = array();
			foreach($converter->data as $name => $rowset) foreach($rowset as $row) $data[$name][] = $row->getData();
			echo json_encode($data);
			//*/
			KFactory::get('lib.koowa.application')->close();
		}
		
		if(KRequest::has('get.print_r')) echo '<pre>', print_r($converter, true), '</pre>';
	}
}