<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: phpbb.php 754 2010-08-19 21:42:45Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

/**
 * ComNinjaboardConverterPhpbb
 *
 * Imports data from phpBB.
 * 
 * @author Stian Didriksen <stian@ninjaforge.com>
 */
class ComNinjaboardConverterPhpbb extends ComNinjaboardConverterAbstract
{
	/**
	 * This converter is able to run in steps
	 *
	 * @var boolean
	 */
	public $splittable = true;

	/**
	 * Import the sample content
	 *
	 * @return $this
	 */
	public function convert()
	{
		$config = array(
			'adapter'		=> KFactory::get('lib.joomla.config')->getValue('dbtype'),
			'username'		=> KRequest::get('post.user', 'cmd', KFactory::get('lib.joomla.config')->getValue('user')),
			'password'		=> KRequest::get('post.password', 'cmd', KFactory::get('lib.joomla.config')->getValue('password')),
			'hostspec'		=> KRequest::get('post.host', 'string', KFactory::get('lib.joomla.config')->getValue('host')),
			'dbname'		=> KRequest::get('post.db', 'string', KFactory::get('lib.joomla.config')->getValue('db')),
			'table_prefix'	=> KRequest::get('post.dbprefix', 'string', KFactory::get('lib.joomla.config')->getValue('dbprefix'))
		);
		//$jdb = KFactory::tmp('lib.koowa.database', $config)->setConnection()->connect();
		$bdb = KFactory::get('lib.joomla.database');
		$jdb = new JDatabaseMySQLi(array(
					'host'	=>	$config['hostspec'],
					'user'	=>	$config['username'],
					'password'	=>	$config['password'],
					'database'	=>	$config['dbname']
				));

		$db = KFactory::get('lib.koowa.database')
			->setConnection($jdb->_resource)
			->setTablePrefix($config['table_prefix']);
		//*/

		$tables = array(
			array(
				'name' => 'forums',
				'options' => array(
					'name' => 'forums',
					'base' => 'forums',
					'identity_column' => 'forum_id'
				),
				'query' => KFactory::tmp('lib.koowa.database.query')
							->select(array(
								'*',
								'forum_name AS title',
								'forum_desc AS description',
								'forum_status AS locked',
								'forum_topics AS topics',
								'forum_posts AS posts',
								'forum_last_post_id AS last_post_id'
							))
			),
			array(
				'name' => 'topics',
				'options' => array(
					'name' => 'topics',
					'base' => 'topics',
					'identity_column' => 'topic_id'
				),
				'query' => KFactory::tmp('lib.koowa.database.query')
							->select(array(
								'*',
								'topic_title AS title',
								'icon_id AS status',
								'topic_last_post_id AS last_post_id',
								'topic_moved_id AS moved_from_forum_id',
								'topic_first_post_id AS first_post_id',
								'topic_replies AS replies',
								'topic_views AS hits'
							))
			),
			array(
				'name' => 'posts',
				'options' => array(
					'name' => 'posts',
					'base' => 'posts',
					'identity_column' => 'post_id'
				),
				'query' => KFactory::tmp('lib.koowa.database.query')
							->select(array(
								'tbl.*',
								'topic_id AS ninjaboard_topic_id',
								'icon_id AS status',
								'poster_id AS created_by',
								'FROM_UNIXTIME(post_time) AS created_on',
								'poster_ip AS user_ip',
								'FROM_UNIXTIME(post_edit_time) AS mofidied_on',
								'post_edit_reason AS edit_reason',
								'post_subject AS subject',
								'post_text AS text'
								//@TODO complete the slashes fix
								//"REPLACE(post_subject, '\'', ".'"\'"'.") AS subject",
							))
			)
		);

		//This returns false if the import is big enough to be done in steps.
		//So we need to stop the importing in this step, in order for it to initiate
		if($this->importData($tables, 'phpbb') === false) return $this;
		
		if(isset($this->data['forums']))
		{
			foreach($this->data['forums'] as $id => $forum)
			{
				if($forum['forum_parents']) $this->data['forums'][$id]['path'] = '/' . implode('/', array_keys(unserialize($forum['forum_parents']))) . '/';
				else $this->data['forums'][$id]['path'] = '/';
			}
		}
		
		///*
		$db = KFactory::get('lib.koowa.database')
			->setConnection($bdb->_resource)
			->setTablePrefix(KFactory::get('lib.joomla.config')->getValue('dbprefix'));
		//*/

		parent::convert();

		return $this;
	}
}