<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: phpbb_users.php 754 2010-08-19 21:42:45Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

/**
 * ComNinjaboardConverterPhpbb
 *
 * Sync phpBB3 users with Ninjaboard
 * 
 * @author Stian Didriksen <stian@ninjaforge.com>
 */
class ComNinjaboardConverterPhpbb_users extends ComNinjaboardConverterPhpbb
{
	/**
	 * Import the sample content
	 *
	 * @return $this
	 */
	public function convert()
	{
		//*/
// jos_ninjaboard_people, jos_ninjaboard_posts, jos_ninjaboard_usergroup_maps, 
		$tables = array(
			/*'people' => array(
				'options' => array(),
				'columns' => array('ninjaboard_person_id'),
				'query' => KFactory::tmp('lib.koowa.database.query')
			),*/
			'posts' => array(
				'options' => array(),
				'columns' => array('created_by', 'modified_by'),
				'query' => KFactory::tmp('lib.koowa.database.query')
			),
		);

		$offset = KRequest::get('post.offset', 'int', false);
		foreach ( $tables as $name => $table )
		{
			if($offset === false)
			{
				$this->data[$name] = KFactory::get('admin::com.ninjaboard.table.'.$name)->count(clone $table['query']);

				continue;
			}
			elseif ($offset !== false)
			{
				$query = KFactory::tmp('lib.koowa.database.query')
					//->select($table['columns'])
					->limit(KRequest::get('post.limit', 'int', 1000), $offset);
			}
			
			$this->data[$name] = KFactory::get('admin::com.ninjaboard.table.'.$name)->select($query);
			
		}

		if($offset === false)
		{
			$total = array_reduce($this->data, 'max');
			$steps = floor($total / KRequest::get('post.limit', 'int', 1000));
			if($steps > 0) 
			{
				echo json_encode(array('splittable' => true, 'total' => $total, 'steps' => $steps));
				return $this;
			}
			else
			{
				foreach ( $tables as $name => $table )
				{
					$this->data[$name] = KFactory::get('admin::com.ninjaboard.table.'.$name)->select(clone $table['query']);
				}
			}
		}
		
		$ids = array();
		foreach($this->data as $table => $rows)
		{
			if(!isset($tables[$table])) continue;
			foreach($rows as $row)
			{
				foreach($tables[$table]['columns'] as $column)
				{
					if($row->$column) $ids[$row->$column] = $row->$column;
				}
			}
		}
		
		$config = array(
					'adapter'		=> KFactory::get('lib.joomla.config')->getValue('dbtype'),
			'username'		=> KRequest::get('post.user', 'cmd', KFactory::get('lib.joomla.config')->getValue('user')),
			'password'		=> KRequest::get('post.password', 'cmd', KFactory::get('lib.joomla.config')->getValue('password')),
			'hostspec'		=> KRequest::get('post.host', 'string', KFactory::get('lib.joomla.config')->getValue('host')),
			'dbname'		=> KRequest::get('post.db', 'string', KFactory::get('lib.joomla.config')->getValue('db')),
			'table_prefix'	=> KRequest::get('post.dbprefix', 'string', KFactory::get('lib.joomla.config')->getValue('dbprefix'))
		);
		//$jdb = KFactory::tmp('lib.koowa.database', $config)->setConnection()->connect();
		$bdb = KFactory::get('lib.joomla.database');
		$jdb = new JDatabaseMySQLi(array(
					'host'	=>	$config['hostspec'],
					'user'	=>	$config['username'],
					'password'	=>	$config['password'],
					'database'	=>	$config['dbname']
				));

		$db = KFactory::get('lib.koowa.database')
			->setConnection($jdb->_resource)
			->setTablePrefix($config['table_prefix']);
		
		$users = KFactory::get('admin::com.phpbb.table.users', array(
			'name' => 'users',
			'base' => 'users',
			'identity_column' => 'user_id'
		))->select(array($ids));
		
		///*
		$db = KFactory::get('lib.koowa.database')
			->setConnection($bdb->_resource)
			->setTablePrefix(KFactory::get('lib.joomla.config')->getValue('dbprefix'));
		//*/
		
		foreach($users as $user)
		{
			$query = KFactory::tmp('lib.koowa.database.query')->select('id')->from('users');
			$ids[$user->id] = $db->fetchField($query->where('username', '=', $user->username_clean)->where('email', '=', $user->user_email));
		}
		
		foreach($this->data as $table => $rows)
		{
			if(!isset($tables[$table])) continue;
			KFactory::get($rows->getTable())->getCommandChain()->disable();
			foreach($rows as $row)
			{
				foreach($tables[$table]['columns'] as $column)
				{
					if($row->$column) $row->$column = $ids[$row->$column];
				}
				$row->save();
			}
			KFactory::get($rows->getTable())->getCommandChain()->enable();
		}
		
		$table = KFactory::get('admin::com.ninjaboard.table.people', array('column_map' => array(
			'user_posts' => 'posts',
			'user_avatar' => 'avatar',
			'user_sig' => 'signature'
		)));
		if(KRequest::get('post.offset', 'int', 0) < 1) $this->_truncateTable($table);
					
		foreach($users as $user)
		{	
			/*	
			$this->row = KFactory::tmp($identifier)
						->getItem()
						->setData($this->row)
						->save(); 
			//*/
			$user->set('id', $ids[$user->id]);

			//Filter the data and remove unwanted columns
			$data = $table->filter($user->getData(), true);
			
			//Get the data and apply the column mappings
			$data = $table->mapColumns($data);
			
			//@TODO find a better way to encode KConfig to json to avoid fatal errors
			/*foreach($data as &$val)
			{
				if(is_a($val, 'KConfig')) $val = $val->toArray();
				if(is_array($val) || is_object($val)) $val = json_encode($val);
				
			}*/
			try {
				$table->getDatabase()->insert($table->getBase(), $data);
			} catch(KDatabaseException $e) {
				//Do nothing, just mute the exception
			}
		}
		
		//die('<pre>'.print_r($ids, true).'</pre>');
		//die('<pre>'.print_r($users, true).'</pre>');
		
		return $this;
	}
}