<?php defined( '_JEXEC' ) or die( 'Restricted access' );
/**
 * @version		$Id: upgrade.php 798 2010-08-31 18:30:20Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */
 

$db	= JFactory::getDBO();
foreach(array(
	'assets',
	'attachments',
	'profile_fields',
	'profile_values',
	'forums',
	'posts',
	'ranks',
	'settings',
	'subscriptions',
	'topics',
	'people',
	'user_groups',
	'user_group_maps',
	'joomla_user_group_maps',
	'templates',
	'iconsets'
) as $name)
{
	$tables[] = '#__ninjaboard_'.$name;
}
$tables = $db->getTableFields($tables);
foreach($tables as $name => $fields)
{
	unset($tables[$name]);
	$tables[str_replace('#__ninjaboard_', '', $name)] = $fields;
}

//Modify assets table
if(isset($tables['assets']['parent_id']))
{
	$db->setQuery('DROP INDEX idx_parent_id ON #__ninjaboard_assets');
	$db->query();
	
	$db->setQuery('DROP INDEX idx_lft_rgt ON #__ninjaboard_assets');
	$db->query();
	
	$db->setQuery('ALTER TABLE #__ninjaboard_assets DROP COLUMN parent_id');
	$db->query();
	
	$db->setQuery('ALTER TABLE #__ninjaboard_assets DROP COLUMN lft');
	$db->query();
	
	$db->setQuery('ALTER TABLE #__ninjaboard_assets DROP COLUMN rgt');
	$db->query();
	
	$db->setQuery('ALTER TABLE #__ninjaboard_assets DROP COLUMN title');
	$db->query();
	
	$db->setQuery('ALTER TABLE #__ninjaboard_assets DROP COLUMN rules');
	$db->query();
	
	$db->setQuery("ALTER TABLE #__ninjaboard_assets CHANGE COLUMN `ninjaboard_asset_id` `ninjaboard_asset_id` BIGINT(20) UNSIGNED NOT NULL auto_increment COMMENT ''  FIRST");
	$db->query();
	
	$db->setQuery("ALTER TABLE #__ninjaboard_assets CHANGE COLUMN `level` `level` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0  COMMENT 'The permission level. 0 = No Access, 1 = Has Access, 2 = and Can Create, 3 = and Can Manage'  AFTER `ninjaboard_asset_id`");
	$db->query();
	
	$db->setQuery("ALTER TABLE #__ninjaboard_assets CHANGE COLUMN `name` `name` VARCHAR(255) NOT NULL DEFAULT ''  COMMENT 'The unique name for the permission object'  AFTER `level`");
	$db->query();
	
	$db->setQuery('ALTER TABLE #__ninjaboard_assets ENGINE = MyISAM');
	$db->query();
}

//Modify forums table
if(isset($tables['forums']['asset_id']))
{
	$db->setQuery('ALTER TABLE #__ninjaboard_forums DROP COLUMN asset_id');
	$db->query();

	$db->setQuery('ALTER TABLE #__ninjaboard_forums DROP COLUMN lft');
	$db->query();
	
	$db->setQuery('ALTER TABLE #__ninjaboard_forums DROP COLUMN rgt');
	$db->query();
	
	$db->setQuery('ALTER TABLE #__ninjaboard_forums DROP COLUMN access');
	$db->query();
	
	$db->setQuery("ALTER TABLE #__ninjaboard_forums CHANGE COLUMN `parent_id` `parent_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0  COMMENT 'Needed for some converters'  AFTER `ninjaboard_forum_id`");
	$db->query();
	
	$db->setQuery("ALTER TABLE #__ninjaboard_forums CHANGE COLUMN `level` `level` INT(10) UNSIGNED NOT NULL DEFAULT 0  COMMENT 'Hierarchy depth'  AFTER `parent_id`");
	$db->query();
	
	$db->setQuery("ALTER TABLE #__ninjaboard_forums CHANGE COLUMN `path` `path` VARCHAR(255) NOT NULL DEFAULT '/'  COMMENT 'Needed for the enumerated path implementation for the forum hierarchies'  AFTER `level`");
	$db->query();
	
	$db->setQuery('ALTER TABLE #__ninjaboard_forums ENGINE = MyISAM');
	$db->query();
}

//Upgrade forums table to allow ordering and sorting
if(!isset($tables['forums']['path_sort']))
{
	$db->setQuery("ALTER TABLE #__ninjaboard_forums ADD COLUMN path_sort TEXT NOT NULL DEFAULT ''  COMMENT 'Cached ordering by path (path+ninjaboard_forum_id)'  AFTER `ordering`");
	$db->query();

	$db->setQuery("ALTER TABLE #__ninjaboard_forums ADD COLUMN path_sort_title TEXT NOT NULL DEFAULT '' COMMENT 'path_sort with ids replaced with forum titles'  AFTER `path_sort`");
	$db->query();

	$db->setQuery("ALTER TABLE #__ninjaboard_forums ADD COLUMN path_sort_ordering TEXT NOT NULL DEFAULT ''  COMMENT 'path_sort with ids replaced with ordering values'  AFTER `path_sort_title`");
	$db->query();
}
