<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: avatars.php 929 2010-09-17 14:49:07Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

/**
 * Ninjaboard Avatars model
 *
 * Gets the avatars, allowing gravatar, cb integration and more through a single interface
 * 
 * @author Stian Didriksen <stian@ninjaforge.com>
 */
class ComNinjaboardModelAvatars extends ComNinjaboardModelPeople
{
	public function __construct($config)
	{
		parent::__construct($config);
		
		$this->_state
					->insert('thumbnail', 'cmd', 'large');
	}

	public function getItem()
	{
		if(!$this->_item)
		{
			$this->_item = parent::getItem();
			$id			 = $this->_item->id ? $this->_item->id : $this->_state->id;
			
			$settings = KFactory::get('site::com.ninjaboard.model.settings')->getParams();
			$settings = $settings['avatar_settings'];
			$this->_item->default = $this->_item->avatar;
			
			$size = $this->_state->thumbnail == 'small' ? 'small' : 'large';
			
			//Always check if there exist an alternate avatar
			if(!JFile::exists(JPATH_ROOT.$this->_item->default) || $this->_item->default == '/media/com_ninjaboard/images/avatar.png') {
				if($settings['enable_gravatar']) {
					//@TODO refactor to use KFactory
					$this->_item->default = new ComNinjaboardHelperGravatar($this->_item->email, array('size' => $size));
					//Gravatars are square, so use the largest value as size
					$gsize = max($settings[$size.'_thumbnail_width'], $settings[$size.'_thumbnail_height']);
					$this->_item->default->size = $gsize;
					$this->_item->default = $this->_item->default->getSrc();

					$image = JFile::read($this->_item->default);
					
					$dest  = '/media/com_ninjaboard/images/avatars/'.$id.'/gravatar.png';
					JFile::write(JPATH_ROOT.$dest, $image);
					$this->_item->default = $dest;
				} else {
					$this->_item->default = '/media/com_ninjaboard/images/avatar.png';
				}
			}

			$this->_item->image = KFactory::get('admin::com.ninja.helper.image', array('image' => JPATH_ROOT.$this->_item->default));
			
			$this->_item->image->resize($settings[$size.'_thumbnail_width'], $settings[$size.'_thumbnail_height']);
			$this->_item->image->quality($settings['thumbnail_quality']);
			
			
		}

		return $this->_item;
	}
}