<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: posts.php 905 2010-09-16 01:36:00Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

/**
 * Ninjaboard Posts model
 *
 * Fetches posts
 * 
 * @author Stian Didriksen <stian@ninjaforge.com>
 */
class ComNinjaboardModelPosts extends KModelTable
{
	/**
	 * Constructor
	 *
	 * @param 	object 	An optional KConfig object with configuration options
	 */
	public function __construct(KConfig $config)
	{
		parent::__construct($config);
		
		$this->_state
						->insert('topic', 'int')
						->insert('id'	, 'int');
	}

	protected function _buildQueryJoins(KDatabaseQuery $query)
	{
		parent::_buildQueryJoins($query);

		$query
			->join('left', 'users AS usr', 'usr.id = tbl.created_user_id')
			->join('left', 'ninjaboard_people AS person', 'person.ninjaboard_person_id = tbl.created_user_id');
			
		if($search = $this->_state->search)
		{
			$query
					->join('left', 'ninjaboard_topics AS topic', 'topic.ninjaboard_topic_id = tbl.ninjaboard_topic_id')
					->join('left', 'ninjaboard_forums AS forum', 'forum.ninjaboard_forum_id = topic.forum_id');
		}
	}
	
	protected function _buildQueryWhere(KDatabaseQuery $query)
	{
		parent::_buildQueryWhere($query);

		$query->where('tbl.enabled', '=', 1, 'and');
		
		if($post = $this->_state->post) $query->where('tbl.ninjaboard_post_id', '=', $post, 'and');
		if($topic = $this->_state->topic) $query->where('tbl.ninjaboard_topic_id', '=', $topic, 'and');
		
		if($search = $this->_state->search)
		{
			$query->where[] = " AND ( `tbl`.`subject` LIKE '%$search%' OR `tbl`.`text` LIKE '%$search%' ) ";
		}
	}
	
	protected function _buildQueryColumns(KDatabaseQuery $query)
	{
		parent::_buildQueryColumns($query);

		$query
			  ->select('usr.*')
			  ->select('person.posts AS person_posts')
			  ->select('tbl.ninjaboard_post_id AS id')
			  ->select("IFNULL(person.avatar, '/media/com_ninjaboard/images/avatar.png') AS avatar")
			  ->select('person.signature')
			  //@TODO figure out how we can combine the ranks query into a single query
			  ->select('(SELECT rank_file FROM #__ninjaboard_ranks WHERE person.posts >= min ORDER BY min DESC LIMIT 1) AS rank_icon')
			  ->select('(SELECT title FROM #__ninjaboard_ranks WHERE person.posts >= min ORDER BY min DESC LIMIT 1) AS rank_title');
			  
		if($search = $this->_state->search)
		{
			$query->select(array('forum.title AS forum', 'topic.ninjaboard_topic_id AS topic', 'topic.hits'));
		}
	}
}