<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: usergroup_maps.php 754 2010-08-19 21:42:45Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

/**
 * Ninjaboard Usergroup maps model
 *
 * @author Stian Didriksen <stian@ninjaforge.com>
 */
class ComNinjaboardModelUsergroup_maps extends KModelTable
{
	/**
	 * Get an array over group ids
	 */
	public function getGroups()
	{
		// Get the data if it doesn't already exist
        if (!isset($this->_groups))
        {
        	$table = KFactory::get($this->getTable());
        	$query = $table->getDatabase()->getQuery();
        	
        	$query->select('ninjaboard_user_group_id');
        	
        	$this->_buildQueryFrom($query);
        	$this->_buildQueryJoins($query);
        	$this->_buildQueryWhere($query);
        	$this->_buildQueryGroup($query);
        	$this->_buildQueryHaving($query);
        	$this->_buildQueryOrder($query);
        	$this->_buildQueryLimit($query);
        	
        	//Create query object
			if(is_numeric($query) || is_array($query))
	       	{
	        	$key    = $this->mapColumns($this->getIdentityColumn());
	           	$values = (array) $query;
	
	       		$query = $this->_database->getQuery()
	        				->where($key, 'IN', $values);
	     	}
	
        	if(!count($query->from)) {
        		$query->from($this->getName().' AS tbl');
			}
	      	
        	$this->_groups = $table->getDatabase()->fetchFieldList($query);	
        }

        return $this->_groups;
	}
}