<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: usergroups.php 759 2010-08-20 23:04:36Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

/**
 * Ninjaboard Usergroups model
 *
 * @TODO look into if we can just delete this file.
 * 
 * @author Stian Didriksen <stian@ninjaforge.com>
 */
class ComNinjaboardModelUsergroups extends KModelTable
{
	/**
     * Get a list over permissions for a group
     *
     * @param  int $id			The primary key
     * @return KDatabaseRowset
     */
    public function getPermissions($id)
    {
    	$table = KFactory::get('admin::com.ninjaboard.table.assets');
    	$query = $table->getDatabase()->getQuery();
    	$prefx = $table->getDatabase()->getTablePrefix();

		$query->where('tbl.name', 'LIKE', 'com_ninjaboard.usergroup.'.$id.'.%');
		
		$permissions = array();
		foreach ($table->select($query, KDatabase::FETCH_ROWSET) as $permission)
		{
			$permission->column	= end(explode('.', $permission->name));
			$permission->title	= KInflector::humanize($permission->column);
			$permissions[$permission->column] = $permission;
		}

    	return $permissions;
    }
    
    /**
     * Query WHERE clause
     */
    protected function _buildQueryWhere(KDatabaseQuery $query)
    {
    	parent::_buildQueryWhere($query);
    
    	if($search = $this->_state->search)
    	{
    		$query->where('tbl.title', 'LIKE', '%'.$search.'%');
    	}
    }
}