<?php defined( 'KOOWA' ) or die( 'Restricted access' );
 /**
 * @version		$Id: forum.php 790 2010-08-30 16:46:32Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

class ComNinjaboardRowForum extends ComNinjaboardRowParam
{
	/**
	 * Recounts stats like posts, topics and latest post
	 *
	 * @return boolean  TRUE if successfull, otherwise false
	 */
	public function recount()
	{
		//Getting all subforum ids, used in following queries
		//@TODO this needs to be optimized
		$database = KFactory::get('lib.koowa.database');
		$table = KFactory::get($this->getTable());
		$query = KFactory::tmp('lib.koowa.database.query')
					->select('ninjaboard_forum_id')
					->where('path', 'like', '%/'.$this->id.'/')
					->from('ninjaboard_forums');
		
		$ids = array_merge(array($this->id), $database->fetchFieldList($query));

		$query = KFactory::tmp('lib.koowa.database.query')
					->select('ninjaboard_topic_id')
					->where('forum_id', 'in', $ids)
					->from('ninjaboard_topics');
		$topics = $database->fetchFieldList($query);
		$this->topics = count($topics);
		
		//If not topics left, don't do any more queries
		if(!$this->topics) {
			$this->posts = 0;
			$this->last_post_id = 0;
			
			return $this->save();
		}
		
		$query = KFactory::tmp('lib.koowa.database.query')
					->select('ninjaboard_post_id')
					->where('ninjaboard_topic_id', 'in', $topics)
					->from('ninjaboard_posts');
		$posts = $database->fetchFieldList($query);
		$this->posts = count($posts);
		
		$query = KFactory::tmp('lib.koowa.database.query')
					->select('ninjaboard_post_id')
					->where('ninjaboard_topic_id', 'in', $topics)
					->from('ninjaboard_posts')
					->order('created_time', 'desc');
		$this->last_post_id = $database->fetchField($query);
		
		return $this->save();
	}
}