<?php defined( 'KOOWA' ) or die( 'Restricted access' );
 /**
 * @version		$Id: param.php 754 2010-08-19 21:42:45Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

/**
 * ComNinjaboardRowParam
 *
 * Table row with a params column. This makes sure global settings are inherited on read, but removed during save
 * 
 * @author Stian Didriksen <stian@ninjaforge.com>
 */
class ComNinjaboardRowParam extends KDatabaseRowAbstract
{
	/**
	 * Params KConfig object, merged with the global params
	 *
	 * @var KConfig
	 */
	protected $_params;

	/**
     * Retrieve row field value
     *
     * @param  	string 	The column name.
     * @return 	string 	The corresponding column value.
     */
    public function __get($column)
    {
    	$result = parent::__get($column);
    
    	if($column != 'params') return $result;
    	
    	if(!isset($this->_params))
		{
			$identifier	= clone $this->getIdentifier();
			$identifier->path = array('model');
			$identifier->name = 'settings';
			$defaults	= KFactory::get($identifier)->getParams()->toArray();
	
			//if(is_array($row->params)) continue;
			//echo $row->params;
			//if(is_array($row->params)) die('<pre>'.var_export(is_string($row->params) && !is_null($row->params), true).'</pre>');
			//$true = false;
			//if(is_array($row->params)) $true = true;
			$params = is_string($result) ? json_decode($result, true) : $result;
	
			//if(!is_array($params)) $params = array();
			//if($true) die('<pre>'.__CLASS__.' '.var_export($params, true).'</pre>');
			if($params !== null) {
				$params = new KConfig($params);
				//@TODO Make this configurable, instead of hardcoding the defaults to only apply when JSite
				$params->append($defaults);
			} else {
				$params = $defaults;
			}

			$this->_params = $params;
		}
    	
    	return $this->_params;
    }
}