<?php defined( 'KOOWA' ) or die( 'Restricted access' );
 /**
 * @version		$Id: user.php 810 2010-09-01 13:57:16Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

/**
 * ComNinjaboardRowUser
 * 
 * @author Stian Didriksen <stian@ninjaforge.com>
 */
class ComNinjaboardRowUser extends KDatabaseRowAbstract
{
	/**
	 * Joomla Usergroup Id cached
	 *
	 * @var integer
	 */
	protected $_jgid = false;

	/**
	 * Joomla Usergroup title cached
	 *
	 * @var string
	 */
	protected $_jgid_title = false;

	/**
	 * Cached rowset of this users Ninjaboard usergroups
	 *
	 * @var KDatabaseRowsetInterface
	 */
	protected $_usergroups = false;

	/**
     * Saves the row to the database.
     *
     * This performs an intelligent insert/update and reloads the properties 
     * with fresh data from the table on success.
     *
     * @return boolean	If successfull return TRUE, otherwise FALSE
     */
    public function save()
    {
    	$result = false;
    	
    	if($this->_new) {
    		$result = KFactory::get($this->getTable())->insert($this);
       	} else {
        	$result = KFactory::get($this->getTable())->update($this);
        }

        return $result;
    }
    
    /**
	* Returns an associative array of the raw data
	*
	* @param   boolean 	If TRUE, only return the modified data. Default FALSE
	* @return  array
	*/
	public function getData($modified = false)
	{
		$result = parent::getData($modified);
	
		//Gets the usergroups
		$result['usergroups'] = $this->usergroups->getData();
		
		return $result;
	}

	/**
     * Retrieve row field value
     *
     * @param  	string 	The column name.
     * @return 	string 	The corresponding column value.
     */
    public function __get($column)
    {
    	$result = parent::__get($column);
    
    	if(!in_array($column, array('joomla_usergroup_id', 'joomla_usergroup_title', 'usergroups'))) return $result;


		//Get data from JUser if not set
		if(!$this->_jgid || !$this->_jgid_title)
		{
			$this->_getJUser();
		}


    	if($column == 'joomla_usergroup_id')
		{			
			return $this->_jgid;
		}
		
		if($column == 'joomla_usergroup_title')
		{
			return $this->_jgid_title;
		}


		if($column == 'usergroups')
		{
			if(!$this->_usergroups)
			{
				$ids = explode('|', $this->ninjaboard_usergroup_id);
				$this->_usergroups = KFactory::tmp('admin::com.ninjaboard.model.usergroups')->id($ids)->getList();
			}

			return $this->_usergroups;
		}
    }

	/**
	 * Method for getting Joomla! details
	 *
	 */
	private function _getJUser()
	{
		$user = JUser::getInstance($this->id);

		$this->_jgid = $user->gid;
		$this->_jgid_title = $user->usertype;

		return $this;
	}
}