<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: usergroup_maps.php 754 2010-08-19 21:42:45Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

/**
 * Ninjaboard Usergroups maps table
 *
 * This table don't follow koowas naming conventions.
 * Thus we hardcode it in.
 * 
 * @author Stian Didriksen <stian@ninjaforge.com>
 */
class ComNinjaboardTableUsergroup_maps extends KDatabaseTableAbstract
{
	/**
	 * Constructor
	 *
	 * @param 	object 	An optional KConfig object with configuration options
	 */
	public function __construct(KConfig $config)
	{
		$config->name		= 'ninjaboard_user_group_maps';
		$config->base		= 'ninjaboard_user_group_maps';
		$config->identity_column	= 'joomla_user_id';

		parent::__construct($config);
	}
	
	public function delete( KDatabaseRowInterface $row )
	{
		//Create commandchain context
		$context = $this->getCommandChain()->getContext();
		$context->caller    = $this;
		$context->operation = KDatabase::OPERATION_DELETE;
		$context->table	  	= $this->getBase();
		$context->data   	= $row;
		
		if($this->getCommandChain()->run('before.table.delete', $context) === true) 
		{
			$query = $this->_database->getQuery();
			
			//Create where statement
			$query->where('joomla_user_id', '=', $context->data->id);

			//Execute the delete query
			$context->affected = $this->_database->delete($context->table, $query);
			
			$this->getCommandChain()->run('after.table.delete', $context);
		}

		return (bool) $context->affected;
	}
}