<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: html.php 754 2010-08-19 21:42:45Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

class ComNinjaboardViewToolsHtml extends ComNinjaboardViewDefault
{
	public function display()
	{
		$this->_createToolbar()
			->reset()
			->append(KFactory::get('admin::com.ninja.toolbar.button.modal', array(
				'text' => 'Settings',
				'handler' => 'adopt',
				'link' => '#settings'
			)));

		$this->menu = KFactory::get('admin::com.ninja.helper.placeholder', array('notice' => 'Select what you want to import.'));
		

		try {
			$legacy = KFactory::get('admin::com.ninjaboard.model.forums_backups')->getTotal();
		} catch(KDatabaseTableException $e) {
			$legacy = false;
		}
		if($legacy) $this->menu->append('legacy', array('onclick' => 'return this;'), JText::_('Ninjaboard 0.5'));
		
		
		$this->menu->append('demo', array('onclick' => 'return this;'), 'Sample content');
		
		
		if(JComponentHelper::getComponent( 'com_agora', true )->enabled)
		{
			$agora = JPATH_BASE.'/components/com_agora/agora.xml';
			$agora = simplexml_load_file($agora);
			//$this->menu->append('agora', array('onclick' => 'return this;'), JText::_('Agora '.$agora->version));
		}
		
		$this->db = JFactory::getDBO();
		$this->menu->append('phpbb', array('onclick' => 'return this;'), 'phpBB3');
		//$this->menu->append('ccboard', array(), 'ccBoard');
		
		$configs = KFactory::get('lib.joomla.config');
		$this->config = new KConfig;
		foreach(array('host', 'user', 'db', 'dbprefix', 'password') as $config)
		{
			$this->config->$config = $configs->getValue($config);
		}
		
		$databases = array();
		foreach(KFactory::get('lib.koowa.database')->fetchFieldList('SHOW DATABASES') as $database)
		{
			$databases[] = array('text' => $database, 'value' => $database);
		}
		$this->assign('databases', $databases);
		
		if(JComponentHelper::getComponent( 'com_kunena', true )->enabled)
		{
			$kunena = JPATH_BASE.'/components/com_kunena/kunena.xml';
			if(!file_exists($kunena)) {
				JError::raiseNotice(0, JText::_('You need to upgrade to Kunena 1.6 or newer in order to use the Kunena converter.'));
			} else {
				$kunena = simplexml_load_file($kunena);
				$this->menu->append('kunena', array('onclick' => 'return this;'), 'Kunena '.$kunena->version);
			}
		}
 
		return parent::display();
	}
}