<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: forum.php 800 2010-08-31 20:10:31Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

/**
 * Ninjaboard Forum Controller
 *
 * @package Ninjaboard
 */
class ComNinjaboardControllerForum extends ComNinjaboardControllerDefault
{
	/**
	 * Constructor
	 *
	 * @param 	object 	An optional KConfig object with configuration options
	 */
	public function __construct(KConfig $config)
	{
		parent::__construct($config);
		
		foreach(array(
			'enabled'	=> true,
			'levels'	=> 3,
			'limit'		=> 0,
			'offset'	=> 0
		) as $key => $val)
		{
			$config->request->$key = $val;
		}
		
		//Set model recurse
		//if(KRequest::method() == 'GET') KRequest::set('get.recurse', true);
		//Set other model states
		//KRequest::set('get.enabled', true);
		
		$this->registerFunctionBefore(array('read', 'browse'), 'setOrdering');
		
		$cache = JPATH_ROOT.'/cache/com_'.$this->getIdentifier()->package . '/maintenance.forums.txt';
		
		if(!JFile::exists($cache))
		{
			KFactory::get('admin::com.ninjaboard.controller.maintenance')->forums();
			JFile::write($cache, date('r'));
		}
	}

	/**
	 * Set forums order
	 *
	 */
	public function setOrdering()
	{
		$params = KFactory::get('admin::com.ninjaboard.model.settings')->getParams();

		if(isset($params->sort)) $this->_request->sort = $params->sort;
		else return true;
		
		KFactory::get($this->getModel())->set($this->getRequest());
	} 
}