<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: topic.php 814 2010-09-01 15:02:02Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

/**
 * Ninjaboard Topic Controller
 *
 * @package Ninjaboard
 */
class ComNinjaboardControllerTopic extends ComNinjaboardControllerDefault
{
	/**
	 * Constructor
	 *
	 * @param 	object 	An optional KConfig object with configuration options
	 */
	public function __construct(KConfig $config)
	{
		parent::__construct($config);

		//Delete related event handlers
		$this->registerFunctionBefore('delete', 'canDelete');
		$this->registerFunctionAfter('delete', 'cleanupDelete');
	}

	/**
	 * Sets the layout to 'default' if view is singular
	 *
	 * @author stian didriksen <stian@ninjaforge.com>
	 * @return void
	 */
	public function _actionRead()
	{
		/*
		if(KRequest::has('get.id') && !KRequest::has('get.layout'))
		{
			
			KRequest::set('get.layout', 'default');
		}
		//*/
		//Force the default layout to form for read actions
		if(!isset($this->_request->layout)) {
			$this->_request->layout = 'default';
		}
		
		return parent::_actionRead();
	}
	
	/**
	 * Checks wether the we can delete this post or not
	 *
	 * @TODO	currently if one post fails the permission check, 
	 *			the command chain is stopped by returning false.
	 *			Change it so posts that can be deleted, are deleted.
	 *
	 * @return boolean	returns false if permission check fails
	 */
	public function canDelete()
	{
		$user = KFactory::get('admin::com.ninjaboard.model.people')->getMe();
		$topics = KFactory::get($this->getModel())->getList();
		foreach($topics as $topic)
		{
			$forum = KFactory::tmp('site::com.ninjaboard.model.forums')
																		->id($topic->forum_id)
																		->getItem();
			$post = KFactory::tmp('site::com.ninjaboard.model.posts')
																		->id($topic->first_post_id)
																		->getItem();

			// @TODO we migth want to add an option later, wether or not to allow users to delete their own post.
			if($forum->post_permissions < 3 && $post->created_by != $user->id) {
				JError::raiseError(403, JText::_("You don't have the permissions to delete others topics."));
				return false;
			}
		}
	}

	/**
	 * Updating forums, topics and users when a post successfully deleted.
	 *
	 * @param $param
	 */
	public function cleanupDelete(KCommandContext $context)
	{
		$topics = $context->result;
		$table = KFactory::get('site::com.ninjaboard.table.posts');
		
		foreach($topics as $topic)
		{
			//@TODO find a better way to set the redirect
			$this->_redirect   		 = 'view=forum&id='.$topic->forum_id;
			$this->_redirect_message = sprintf(JText::_('Topic «%s» deleted.'), $topic->subject);
		
			$query = KFactory::tmp('lib.koowa.database.query')->where('ninjaboard_topic_id', '=', $topic->id);
			$table->select($query, KDatabase::FETCH_ROWSET)->delete();
			
			//Update the forums' topics and posts count, and correct the last_post_id column
			$forums	= KFactory::tmp('site::com.ninjaboard.model.forums')->id($topic->forum_id)->getListWithParents();
			$forums->recount();
		}
	}
}