<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: paginator.php 840 2010-09-13 19:21:18Z stian $
 * @package		Ninja
 * @copyright	Copyright (C) 2010 NinjaForge. All rights reserved.
 * @license 	GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */
 
KLoader::load('admin::com.ninja.helper.paginator');

class ComNinjaboardHelperPaginator extends ComNinjaHelperPaginator
{	
	/**
	 * Render item pagination
	 *
	 * @param	int	Total number of items
	 * @param	int	Offset for the current page
	 * @param	int	Limit of items per page
	 * @param	int	Number of links to show before and after the current page link
	 * @return	string	Html
	 * @see  	http://developer.yahoo.com/ypatterns/navigation/pagination/
	 */
	public function pagination($total, $offset, $limit, $display = null, $ajax = false)
	{
		$this->_ajax = (bool) $ajax;
		if(is_string($ajax)) $this->_ajax_layout = $ajax;
		KFactory::get('admin::com.ninja.helper')->css('/pagination.css');

		// Paginator object
		$paginator = KFactory::tmp('lib.koowa.model.paginator')->setData(
				array('total'  => $total,
					  'offset' => $offset,
					  'limit'  => $limit,
					  'dispay' => $display)
		);
		
		$view = $this->name;
		$items = (int) $total === 1 ? KInflector::singularize($view) : $view;
		//if($total <= 10) return '<div class="pagination"><div class="limit">'.sprintf(JText::_(KInflector::humanize($items)) . ' %s', $total ).'</div></div>';

		// Get the paginator data
		$list = $paginator->getList();
		$limitlist = $total > $limit ? $this->limit(array('state' => array('limit' => $limit))) : $total;
		
		$html  = '<div class="pagination">';
		$html .= '<div class="limit">'.sprintf(JText::_(KInflector::humanize($items)) . ' %s', $total ).'</div>';
		$html .=  $this->pages($list);
		$html .= '<div class="count"> '.JText::_('Pages').' '.$paginator->current.' '.JText::_('of').' '.$paginator->count.'</div>';
		$html .= '</div>';

		return $html;
	}
}