<?php
 /**
 * @version		$Id: ninjaboard.php 846 2010-09-15 01:54:54Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
 
//@TODO add proper error handling when com_ninja don't exist
$ninja = JPATH_ADMINISTRATOR.'/components/com_ninja/ninja.php';
if(file_exists($ninja)) require_once $ninja;
else					return;

/** 
* If either of the frameworks is unavailable
* Abort the dispatcher
*/
if( !defined('KOOWA') ) return false;


// 0.5 legacy
if(KRequest::get('get.view', 'cmd') == 'board') 		KRequest::set('get.view', 'forums');
if(KRequest::get('get.layout', 'cmd') == 'ninjaboard')	unset($_GET['layout']);


// We like code reuse, so we map the frontend models to the backend models
foreach(array('avatars', 'forums', 'settings', 'users', 'usergroups', 'people', 'profiles', 'topics', 'posts', 'attachments') as $model)
{
	KFactory::map('site::com.ninjaboard.model.'.$model, 'admin::com.ninjaboard.model.'.$model);
}

foreach(array('forum') as $row)
{
	KFactory::map('site::com.ninjaboard.row.'.$row, 'admin::com.ninjaboard.row.'.$row);
}

KFactory::map('site::com.ninjaboard.table.topics', 	'admin::com.ninjaboard.table.topics');
KFactory::map('site::com.ninjaboard.table.posts', 	'admin::com.ninjaboard.table.posts');
KFactory::map('site::com.ninjaboard.table.attachments', 	'admin::com.ninjaboard.table.attachments');
KFactory::map('site::com.ninjaboard.table.users', 	'admin::com.ninjaboard.table.users');
KFactory::map('site::com.ninjaboard.table.people', 	'admin::com.ninjaboard.table.people');
KFactory::map('site::com.ninjaboard.table.settings', 	'admin::com.ninjaboard.table.settings');

//@TODO temporary mappings
KFactory::map('site::com.ninjaboard.model.rules', 	'admin::com.ninjaboard.model.profile_fields');
KFactory::map('site::com.ninjaboard.model.helps', 	'admin::com.ninjaboard.model.profile_fields');

//Set napi to load jquery scripts instead of mootools
KFactory::get('admin::com.ninja.helper.default')->framework('jquery');

//Don't deal with mootools and don't lead jquery lib if morph is the template
if(KFactory::get('lib.joomla.application')->getTemplate() != 'morph') {
	$document = KFactory::get('lib.joomla.document');
	$config   = KFactory::get('lib.joomla.config');
	$debug    = $config->getValue('config.debug');
	
	$script = $debug ? '-uncompressed.js' : '.js';
	$script = KRequest::root().'/media/system/js/mootools'.$script;
	$jquery = KFactory::get('admin::com.ninja.helper')->js('/jquery.min.js');
	
	KRequest::set('session.application.scripts.mootools', $script, 'string');
	KRequest::set('session.application.scripts.jquery', $jquery, 'string');
	KRequest::set('session.application.mootools.prioritize', true, 'boolean');
	
	$mootools= KFactory::get('admin::com.ninja.command.mootools');
	
	KFactory::get('lib.koowa.event.dispatcher')->register($mootools);
	
	//Load the ninjaboard plugins
	JPluginHelper::importPlugin('ninjaboard', null, true, KFactory::get('lib.koowa.event.dispatcher'));
}

// Create the component dispatcher
KFactory::get('site::com.ninjaboard.dispatcher')->dispatch(KRequest::get('get.view', 'cmd', 'forums'));

// Add untranslated words to the current NB language file
KFactory::get('admin::com.ninja.helper.language');