<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: file.php 903 2010-09-16 00:43:28Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */
 
class ComNinjaboardViewAvatarFile extends KViewFile
{
	/**
	 * Default mimetype
	 *
	 * @var string
	 */
	public $mimetype = ' ';

	public function display()
	{
		//Prepare MediaHelper
		JLoader::register('MediaHelper', JPATH_ROOT.'/components/com_media/helpers/media.php');
	
		$avatar = KFactory::get($this->getModel())->getItem();

		$avatar->type = MediaHelper::getTypeIcon($avatar->default);
		$path = JPATH_ROOT.$avatar->default;
		
		$this->mimetype = 'image/'.$avatar->type;
		
		$this->disposition = 'inline';
		$image = $avatar->image;		
		
		$cache = JPATH_CACHE.'/com_ninjaboard/avatars/'.$avatar->id.'?'.http_build_query($image->actions).'.'.$image->ext;
		if(!JFile::exists($cache)) {
			//To avoid "image directory unwritable" messages
			JFile::write($cache, '');
			
			$image->save($cache);
		} else {
			//Time since created, in seconds
			$created = time()-date('U', filemtime($cache));
			//When cache is expired, which is 24hrs
			$expire	 = 60 * 60 * 24;
			
			if($created > $expire) $image->save($cache);
		}
		$this->output = JFile::read($cache);
		$this->defaultname = basename($avatar->default);

		return parent::display();
	}
}