<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: default.php 754 2010-08-19 21:42:45Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */

KLoader::load('admin::com.ninja.view.default');

class ComNinjaboardViewDefault extends ComNinjaViewDefault
{
	/**
	 * An boolean to disable the toolbar when needed
	 *
	 * @var boolean
	 */
	protected $_toolbar = false;

	/**
	 * A menu object
	 *
	 * @var object
	 */
	protected $_menu;

	/**
	 * The active menu item object
	 *
	 * @var object
	 */
	protected $_active;
	
	/**
	 * The current ordering
	 *
	 * @var int
	 */
	private $__ordering = 0;

	/**
	 * Constructor
	 *
	 * @param 	object 	An optional KConfig object with configuration options
	 */
	public function __construct(KConfig $config = null)
	{
	    //If no config is passed create it
		if(!isset($config)) $config = new KConfig();
		
		parent::__construct($config);
	        
		$this->_menu = $config->menu;
		$this->_active = $config->active;
	}

	/**
	 * Initializes the options for the object
	 *
	 * Called from {@link __construct()} as a first step of object instantiation.
	 *
	 * @param 	object 	An optional KConfig object with configuration options
	 * @return  void
	 */
	protected function _initialize(KConfig $config)
	{
		$config->append(array(
	        'menu'      => KFactory::get('lib.koowa.application')->getMenu(),
	        'active'	=> KFactory::get('lib.koowa.application')->getMenu()->getActive()
	   	));
	   	
	   	parent::_initialize($config);
	}

	protected function _createMenuLink($link)
	{
		return JRoute::_('index.php?' . $link . '&Itemid=' . $this->_active->id);
	}

	protected function _addMenuItem(array $append = array())
	{
		if(!isset($append['alias'])) {
			$append['alias'] = KFactory::get('lib.koowa.filter.slug')->sanitize($append['name']);
		} else {
			$append['alias'];
		}
	
		$item = (object)array_merge((array)$this->_active, array(
		       'id' => $append['id'],
		       'type' => 'url',
		       'parent' => $this->_active->id,
		       'ordering' => $this->__ordering++,
		       'sublevel' => $this->_active->sublevel + 1,
		       'route' => $this->_active->route.'/'.$append['alias'],
		    ), $append);
		/*
		echo ('<pre>'.print_r($this->_active, true).'</pre>');
		die('<pre>'.print_r($item, true).'</pre>');
		//*/
		$items = $this->_menu->getMenu();

		$items[$append['id']] = $item;
		$this->_menu->set('_items', $items);

		if(KRequest::get('get.view', 'cmd') == $append['view']) $this->set_active = $append['id'];

		return $this;
	}
	
	/**
	 * @TODO this is just copied from JMenu
	 * Loads the entire menu table into memory
	 *
	 * @access public
	 * @return array
	 */
	function load()
	{
		// Initialize some variables
		$db		= & JFactory::getDBO();

		$sql	= 'SELECT m.*, c.`option` as component' .
				' FROM #__menu AS m' .
				' LEFT JOIN #__components AS c ON m.componentid = c.id'.
				' WHERE m.published = 1'.
				' ORDER BY m.sublevel, m.parent, m.ordering';
		$db->setQuery($sql);

		if (!($menus = $db->loadObjectList('id'))) {
			JError::raiseWarning('SOME_ERROR_CODE', "Error loading Menus: ".$db->getErrorMsg());
			return false;
		}

		foreach($menus as $key => $menu)
		{
			//Get parent information
			$parent_route = '';
			$parent_tree  = array();
			if(($parent = $menus[$key]->parent) && (isset($menus[$parent])) &&
				(is_object($menus[$parent])) && (isset($menus[$parent]->route)) && isset($menus[$parent]->tree)) {
				$parent_route = $menus[$parent]->route.'/';
				$parent_tree  = $menus[$parent]->tree;
			}

			//Create tree
			array_push($parent_tree, $menus[$key]->id);
			$menus[$key]->tree   = $parent_tree;

			//Create route
			$route = $parent_route.$menus[$key]->alias;
			$menus[$key]->route  = $route;

			//Create the query array
			$url = str_replace('index.php?', '', $menus[$key]->link);
			if(strpos($url, '&amp;') !== false)
			{
			   $url = str_replace('&amp;','&',$url);
			}

			parse_str($url, $menus[$key]->query);
		}

			$cache->store(serialize($menus), 'menu_items');
		$this->_items = $menus;
	}

	public function display()
	{
		//@TODO the following is just a quick test concept, for allowing us to add links directly to the current menu linking to ninjaboard.
	
		$user = KFactory::get('lib.joomla.user');
	
		$items = array('forums', 'topics', false, false, 'rules', 'help');
		if(!$user->guest) {
			$items[2] = (object)array('link' => 'topics&at=' . $user->id, 'title' => '@' . $user->username);
			$items[3] = 'profile';
		} else {
			$items[2] = 'login';
		}
		
		foreach(array_filter($items) as $item)
		{
			continue;
			$id	  = rand();
			$link = is_object($item) ? $item->link : $item;
			$item = is_object($item) ? $item->title : $item;
			$link = $this->_createMenuLink('option=com_ninjaboard&view=' . $link);
		
			$this->_addMenuItem(array(
				'id'   => $id,
				'name' =>  KInflector::humanize($item),
				'link' =>  $link,
				'view' =>  $item,
				'query' => array($link => '')
			));
		}
		if(isset($this->set_active)) $this->_menu->setActive($this->set_active);
	
		/*
		$menu = KFactory::get('lib.koowa.application')->getMenu();
		$item = (object)array(
		       'id' => '53',
		       'menutype' => 'mainmenu',
		       'name' => 'Test',
		       'alias' => 'test',
		       'link' => 'http://www.joomla.org',
		       'type' => 'url',
		       'published' => '1',
		       'parent' => '0',
		       'componentid' => '0',
		       'sublevel' => '0',
		       'ordering' => '1',
		       'checked_out' => '0',
		       'checked_out_time' => '0000-00-00 00:00:00',
		       'pollid' => '0',
		       'browserNav' => '0',
		       'access' => '0',
		       'utaccess' => '3',
		       'params' => 'menu_image=-1
		
		',
		       'lft' => '0',
		       'rgt' => '0',
		       'home' => '0',
		       'component' => NULL,
		       'tree' => 
		      array (
		        0 => '11',
		      ),
		       'route' => 'joomla-home',
		       'query' => 
		      array (
		        'http://www_joomla_org' => '',
		      ),
		    );
		
		$menu->set('_items', array_merge($menu->getMenu(), array(999 => $item)));*/
		//die('<pre>'.print_r($menu->getMenu(), true).'</pre>');
	
		$this->js('/site.js');
		$this->assign('dateformat', str_replace(array('%A', '%B'), array('%a', '%b'), JText::_('DATE_FORMAT_LC2')));
		$timezone = KFactory::tmp('lib.joomla.user')->getParam('timezone');
		if(is_null($timezone)) $timezone = KFactory::get('lib.joomla.config')->getValue('offset');
		$this->assign('timezone', $timezone);
		
		return parent::display();
	}

	/**
	 * Function for getting a plural and human readable version of a name
	 *
	 * @author Stian Didriksen <stian@ninjaforge.com>
	 * @param  bool $pluralize	Wether to pluralize or not
	 */
	public function getReadableName($pluralize = true)
	{
		$name = $this->getName();
		if($pluralize && KInflector::isSingular($name)) $name = KInflector::pluralize($name);
		return KInflector::humanize($name);
	}
}