<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: html.php 815 2010-09-01 15:58:59Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */
 
class ComNinjaboardViewForumHtml extends ComNinjaboardViewDefault
{
	public function display()
	{

		$model = KFactory::get($this->getModel());
		$forum = $model->getItem();
		$this->_subtitle = $forum->title;

		if(!$forum->id)
		{
			if(KFactory::get('lib.joomla.user')->guest)
			{
				$this->mixin(KFactory::get('admin::com.ninja.view.user.mixin'));
				
				$this->setLoginLayout();
				
				return parent::display();
			}
			else
			{
				$this->title = JText::_("Access to this forum declined");
				$this->msg	 = JText::_('Contact an administrator immidiatly if this is an mistake.');
				JError::raiseError(404, JText::_('Forum not found'));
				return parent::display();
			}
		}
		
		$forums = KFactory::tmp('site::com.ninjaboard.model.forums')->enabled(true)->recurse(1)->path($forum->id);
		$this->assign('forums', $forums->getList());
		
		$this->limit	= KRequest::get('get.limit', 'int', 10);
		$this->total	= KFactory::tmp('site::com.ninjaboard.model.topics')
							->direction('desc')
							->sort('first_post.created_time')
							->forum($forum->id)
							->limit($this->limit)
							->offset(KRequest::get('get.offset', 'int', 0))
							->getTotal();
		
		$this->assign('topics', 
			KFactory::get('site::com.ninjaboard.controller.topic')
				->direction('desc')
				->sort('first_post.created_time')
				->limit($this->limit)
				->offset(KRequest::get('get.offset', 'int', 0))
				->forum($forum->id)
				->layout('list')
				->browse()
		);
		
		$this->assign('pagination', 
			KFactory::get('site::com.ninjaboard.helper.paginator', array('name' => 'topics'))
				->pagination($this->total, KRequest::get('get.offset', 'int', 0), $this->limit, 4)
		);
		
		if($forums->getTotal())
		{
			$title = JText::_('Forums');
			if(isset($forum->params['forum_view_settings']['displayed_elements']))
			{
				$showtitle = in_array('subforums_forums_title', $forum->params['forum_view_settings']['displayed_elements']);
				if(!$showtitle) $title = false;
			}
			ob_start();
			echo $this->loadTemplate('site::com.ninjaboard.view.forum.block_subforums');
			$this->assign('block_subforums', $this->render(ob_get_clean(), $title, $forum->params['module']));
		}
		else
		{
			$this->assign('block_subforums', false);
		}


		$this->new_topic_button = $forum->topic_permissions > 1 ? str_replace(
			array('$title', '$link'), 
			array(JText::_('New Topic'), $this->createRoute('view=post&forum='.$forum->id)), 
			$forum->params['tmpl']['new_topic_button']
		) : false;
		
		$this->assign('toolbar', $this->new_topic_button);
		
		//$this->placeholder = $this->placeholder('topics', array('href' => $this->createRoute('view=post&forum='.$forum->id)));

		$pathway = KFactory::get('lib.koowa.application')->getPathWay();

		$this->setLayout('default');
		
		$return = parent::display();
		
		foreach($this->forum->getParents() as $parent)
		{
			$pathway->addItem($parent->title, $this->createRoute('view=forum&id='.$parent->id));
		}
		$pathway->addItem($forum->title, $this->createRoute('view=forum&id='.$forum->id));
		
		return $return;
	}
}