<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: html.php 754 2010-08-19 21:42:45Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */
 
class ComNinjaboardViewPostHtml extends ComNinjaboardViewDefault
{
	public function display()
	{
		$this->assign('params', KFactory::get('admin::com.ninjaboard.model.settings')->getParams());
	
		$post					= KFactory::get($this->getModel())->getItem();
		if(!$post->ninjaboard_topic_id) $post->ninjaboard_topic_id = KRequest::get('get.topic', 'int');
		$this->topic = $topic	= KFactory::get('site::com.ninjaboard.model.topics')
									->id($post->ninjaboard_topic_id)
									->getItem();
		if(!$topic->forum_id) $topic->forum_id = KRequest::get('get.forum', 'int');
		$this->forum = $forum	= KFactory::get('site::com.ninjaboard.model.forums')->id($topic->forum_id)->getItem();

		if((!$forum->id || $forum->post_permissions < 2) && KFactory::tmp('lib.joomla.user')->guest)
		{
			$this->mixin(KFactory::get('admin::com.ninja.view.user.mixin'));
			
			$this->setLoginLayout();
			
			return parent::display();
		}
		elseif(!$forum->id || $forum->post_permissions < 2)
		{
			//JError::raiseNotice(401, JText::_("You don't have the permissions to post in this forum."));
			return;
		}
		
		if(!empty($post->id) && $topic->first_post_id == $post->id) {
			$title = sprintf(JText::_('Editing post «%s»'), $post->subject);
		} else if($post->id) {
			$title = JText::_('Editing post');
		} else if($topic->id) {
			$title = sprintf(JText::_('Replying topic %s'), $topic->title);
		} else {
			$title = JText::_('New topic');
		}
		
		$this->_subtitle = $title;
		$this->assign('title', $title);

		if($post->id) $title = JText::_('Edit post');
		else if($topic->id) $title = JText::_('Reply topic');
		else $title = JText::_('Create topic');
		$this->create_topic_button = str_replace('$title', $title, $this->params['tmpl']['create_topic_button']);

		//if($topic->id && !KRequest::get('get.layout', 'cmd', false)) $this->setLayout('default');
		
		$this->post = KFactory::get('site::com.ninjaboard.model.posts')->id(KRequest::get('get.post', 'int'))->getItem();
		$this->assign('attachments', $post->id ? KFactory::tmp('site::com.ninjaboard.model.attachments')->post($post->id)->getList() : array());

		$output = parent::display();

		$pathway	= KFactory::get('lib.koowa.application')->getPathWay();		
		
		$forum		= KFactory::get('site::com.ninjaboard.model.forums')->id($topic->forum_id)->getItem();
		
		foreach($forum->getParents() as $parent)
		{
			$pathway->addItem($parent->title, $this->createRoute('view=forum&id='.$parent->id));
		}
		$pathway->addItem($forum->title, $this->createRoute('view=forum&id='.$forum->id));
		
		//if($topic->first_post_id === $post->id) $pathway->addItem($topic->subject, $this->createRoute('view=topic&id='.$topic->id));
		$pathway->addItem($this->_subtitle, $this->createRoute('view=topic&id='.$topic->id));
		
		return $output;
	}
}