<?php defined( 'KOOWA' ) or die( 'Restricted access' );
/**
 * @version		$Id: html.php 905 2010-09-16 01:36:00Z stian $
 * @category	Ninjaboard
 * @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://ninjaforge.com
 */
 
class ComNinjaboardViewTopicHtml extends ComNinjaboardViewDefault
{
	public function display()
	{
		$topic 	  = KFactory::get($this->getModel())->getItem();
		$this->forum 	  = KFactory::get('site::com.ninjaboard.model.forums')->id($topic->forum_id)->getItem();
		$this->user = KFactory::get('lib.joomla.user');
		
		//Assign forum permissions to topic
		$topic->forum_permissions = $this->forum->forum_permissions;
		$topic->topic_permissions = $this->forum->topic_permissions;
		$topic->post_permissions = $this->forum->post_permissions;
		$topic->attachment_permissions = $this->forum->attachment_permissions;
		
		if((!$this->forum->id || !$topic->id) && KFactory::tmp('lib.joomla.user')->guest)
		{
			$this->mixin(KFactory::get('admin::com.ninja.view.user.mixin'));
			
			$this->setLoginLayout();
			
			return parent::display();
		}
		elseif(!$topic->id)
		{
			JError::raiseError(404, JText::_("Topic not found."));
			return;
		}
		elseif(!$this->forum->id)
		{
			JError::raiseError(404, JText::_("Forum not found."));
			return;
		}
		
		$this->_subtitle = $topic->title;

		//if($topic->id && !KRequest::get('get.layout', 'cmd', false)) $this->setLayout('default');

						
		//@TODO make posts limit configurable, not hardcoded to 6
		$this->assign('posts',
			KFactory::get('site::com.ninjaboard.controller.post')
				//->direction('desc')
				//->sort('first_post.created_time')
				->limit(6)
				->offset(KRequest::get('get.offset', 'int', 0))
				->topic($topic->id)
				->layout('default')
				->browse()
		);

		$this->reply_topic_button = $this->forum->post_permissions > 1 ? '<a class="button" href="'.$this->createRoute('view=post&topic='.$topic->id).'"<span class="symbol reply"></span>' . JText::_('Reply Topic') . '</a>' : null;
		
		$this->lock_topic_button = $this->forum->topic_permissions > 2 ? $this->_createActionButton('lock', 'Lock topic', $topic->id, 'lock') : null;
		//$this->merge_topic_button = $this->forum->topic_permissions > 2 ? $this->_createActionButton('merge', 'Merge topic', $topic->id, 'merge') : null;
		$this->merge_topic_button = null;
		$this->delete_topic_button = $this->forum->topic_permissions > 2 ? $this->_createActionButton('delete', 'Delete topic', $topic->id, 'trash') : null;

		$output = parent::display();
		
		$pathway	= KFactory::get('lib.koowa.application')->getPathWay();
		
		foreach($this->forum->getParents() as $parent)
		{
			$pathway->addItem($parent->title, $this->createRoute('view=forum&id='.$parent->id));
		}
		$pathway->addItem($this->forum->title, $this->createRoute('view=forum&id='.$this->forum->id));
		
		$pathway->addItem($topic->subject ? $topic->subject : JText::_('New Topic'), $this->createRoute('view=topic&id='.$topic->id));

		$hit = KRequest::get('session.'.KFactory::get('admin::com.ninja.helper')->formid($topic->id), 'boolean');
		$me  = KFactory::get('admin::com.ninjaboard.model.people')->getMe();
		if(!$hit && $topic->created_user_id != $me->id)
		{
			$topic->hit();
			KRequest::set('session.'.KFactory::get('admin::com.ninja.helper')->formid($topic->id), true);
		}
		
		return $output;
	}
	
	private function _createActionButton($action, $title, $id, $symbol = '&#8986;')
	{
		return '<form action="'.$this->createRoute('view=topic&id='.$id.'&action='.$action).'" method="post" style="display:inline"><input type="hidden" name="action" value="'.$action.'" /><input type="hidden" name="_token" value="'.JUtility::getToken().'" /><a href="#" class="button '.$action.' '.KFactory::get('admin::com.ninja.helper')->formid($action).'">' . JText::_($title) . '</a></form>';
	}
	
	public function _createToolbar()
	{
		return $this;
	}
	
	public function renderTitle()
	{
		return;
	}
}