<?php
// $Id: install.php 456 2010-08-28 20:03:53Z stian $

defined( '_JEXEC' ) or die( 'Restricted access' );

//This file is crucial for the install to work.
require_once 'helper.php';

$this->name = strtolower($this->name);

$extname = 'com_' . $this->name;

// load the component language file
$language = &JFactory::getLanguage();
$language->load($extname);

$source = $this->parent->getPath('source');

//Required data are root path, 
$install = new NinjaInstallHelper($this);
$manifests = $install->manifests;
$extensions = array();
foreach ($manifests as $manifest)
{
	$extensions[] = simplexml_load_file($manifest);
}
$extension = simplexml_load_file($this->parent->getPath('manifest'));
$exists = array();
$existing = $install->exists ? $install->exists : array();
foreach ($existing as $manifest)
{
	$exists[] = simplexml_load_file($manifest);
}

function humanize ($word)
{
	return ucwords(strtolower(str_replace("_", " ", $word)));
}

$versiontext = '<em>'.JText::_('You need at least %s to use ' . JText::_(humanize($extension->name)) . ' You are using: %s').'</em>';

/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * OUTPUT TO SCREEN
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/
$rows = 0;
//JFactory::getDocument()->addScriptDeclaration('console.group(\'' . JText::_('Install Log') . '\');console.debug(' . json_encode($install) .');console.groupEnd();');
?>
<table>
	<tbody valign="top">
		<tr>
			<td style="text-align: center">
				
				<a href="<?php echo JRoute::_('&option='.$extname) ?>"><img src="<?php echo JURI::root() ?>media/com_<?php echo $this->name ?>/images/256/<?php echo $this->name ?>.png" alt="<?php echo JText::_('Extension logo') ?>" title="<?php echo JText::_('Extension logo') ?>" /></a>
				<div class="button2-left" style="white-space: pre"><div class="blank"><a href="<?php echo JRoute::_('&option='.$extname.'&view=dashboard') ?>"><?php echo JText::_('Visit '.JText::_(humanize($extension->name)).' now to finish the installation.') ?></a></div></div>
			</td>
			<td width="100%">
				<table class="adminlist ninja-list">
					<thead>
						<tr>
							<th><?php echo JText::_('Task') ?></th>
							<th width="30%"><?php echo JText::_('Status') ?></th>
						</tr>
					</thead>
					<tfoot>
						<tr>
							<td colspan="5"></td>
						</tr>
					</tfoot>
					<tbody>
						<tr class="row0">
							<td class="key hasTip" title="<?php echo sprintf($versiontext, 'PHP v5.2.7', phpversion()) ?>"><?php echo JText::_('PHP Version') ?></td>
							<td>
								<?php echo version_compare(phpversion(), '5.2.7', '>=')
									? '<strong>'.JText::_('OK').'</strong> - '.phpversion()
									: sprintf($versiontext, 'PHP v5.2', phpversion()); ?>
							</td>
						</tr>
						<tr class="row1">
							<td class="key hasTip" title="<?php echo sprintf($versiontext, 'MySQL v5.0.41', $db->getVersion()) ?>"><?php echo JText::_('MySQL Version') ?></td>
							<td>
								<?php echo version_compare($db->getVersion(), '5.0.41', '>=')
								? '<strong>'.JText::_('OK').'</strong> - '.$db->getVersion()
								: sprintf($versiontext, 'MySQL v5.0.41', $db->getVersion()); ?>
							</td>
						</tr>
						<tr class="row0">
							<td class="key hasTip" title="<?php echo JText::_($extension->description) ?>"><?php echo sprintf('%s %s', JText::_(humanize($extension->name)), JText::_(ucfirst($extension['type']))) ?></td>
							<td><strong><?php echo JText::_('Installed'); ?></strong> - <?php echo $extension->version ?></td>
						</tr>
						<?php $installed = array(); ?>
						<?php foreach ($extensions as $package) : ?>
						<?php $installed[] = (string)$package->name; ?>
						<tr class="row0">
							<td class="key hasTip" title="<?php echo JText::_($package->description) ?>"><?php echo sprintf('%s %s', JText::_(humanize($package->name)), JText::_(ucfirst($package['type']))) ?></td>
							<td><strong><?php echo JText::_('Installed'); ?></strong> - <?php echo $package->version ?></td>
						</tr>
						<?php endforeach ?>
						<?php foreach ($exists as $exist) : ?>
						<?php if(in_array((string)$exist->name, $installed)) continue; ?>
						<tr class="row0">
							<td class="key hasTip" title="<?php echo JText::_($exist->description) ?>"><?php echo sprintf('%s %s', JText::_(humanize($exist->name)), JText::_(ucfirst($exist['type']))) ?></td>
							<td><strong><?php echo JText::_('OK'); ?></strong> - <?php echo $exist->version ?></td>
						</tr>
						<?php endforeach ?>
					</tbody>
				</table>
			</td>
		</tr>
	</tbody>
</table>
<?php
	//Run extension specific upgrade procedure if found
	$upgrade = dirname(__FILE__).'/upgrade.php';
	if(file_exists($upgrade)) require_once $upgrade;


	if(!isset($extension->migrate)) return;
	
	jimport('joomla.filesystem.file');
	$admin	   = JPATH_ADMINISTRATOR."/components/$extname/admin.$this->name.php";
	
	$oldcom    = basename($admin);
	$newcom    = $this->name.'.php';
	$migrate   = 'migrate.php';
	
	if(!file_exists(dirname(__FILE__).'/'.$migrate)) return;
	
	if(isset($extension->migrate['condition']) && eval($extension->migrate['condition'])) require_once $migrate;	
	
	if(file_exists($admin)) JFile::delete($admin);

// To allow multiple components to be installed in a single go, crucial to have this check
if(!function_exists('com_install'))
{
	/**
	 * This function is required by JInstallerComponent in order to run this script
	 *
	 * @return	boolean	true
	 */
	function com_install()
	{
		// If MySQLi isn't available at all, roll back
		return function_exists('mysqli_connect');
	}
}