/**
 * @version		$Id: tabs.js 485 2010-09-16 02:47:20Z stian $
 * @category    Koowa
 * @package     Koowa_Media
 * @subpackage  Javascript
 * @copyright	Copyright (C) 2007 - 2009 Johan Janssens and Mathias Verraes. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link     	http://www.koowa.org
 */
 
/**
 * Tabs behavior
 *
 * @package     Koowa_Media
 * @subpackage	Javascript
 */
var KTabs = new Class({
	Implements: [Options, Events],
    options: {
    
        display: 	0,
        
        height:		null,

        onActive: function(title, description){
            description.show();
            title.swapClass('closed', 'open');
        },

        onBackground: function(title, description){
            description.hide();
            title.swapClass('open', 'closed');
        }
    },

    initialize: function(dlist, options)
    {
        this.dlist = $(dlist);
        this.setOptions(options);
        this.titles = this.dlist.getChildren('dt');
        this.descriptions = this.dlist.getChildren('dd');
        this.content = new Element('div').injectAfter(this.dlist).addClass('current');
          
        if(this.options.height) {
        	this.content.setStyle('height', this.options.height);
        }

        for (var i = 0, l = this.titles.length; i < l; i++)
        {
            var title = this.titles[i];
            title.setStyle('cursor', 'pointer');
            title.addEvent('click', this.display.bind(this, i));
        }
        this.descriptions.injectInside(this.content);
		
		if(Cookie.read('ktabs.' + dlist)) this.options.display = Cookie.read('ktabs.' + dlist);
        if ($chk(this.options.display)) this.display(this.options.display);

        if (this.options.initialize) this.options.initialize.call(this);
    },

    hideAllBut: function(but)
    {
        this.fireEvent('onBackground', [this.titles.filter(function(e, index){ return index !== but; }), this.descriptions.filter(function(e, index){ return index !== but; })]);
    },
    
    display: function(i)
    {
    	Cookie.write('ktabs.' + this.dlist.get('id'), i);
        this.hideAllBut(i);
        this.fireEvent('onActive', [this.titles[i], this.descriptions[i]])
    }
});