<?php
/**
 * @version		$Id: packages.php 414 2010-08-06 09:48:31Z stian $
 * @package		Koowa
 * @copyright	Copyright (C) 2009 - 2010 Nooku. All rights reserved.
 * @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
 * @link		http://www.nooku.org
 */

class ComKoowaModelPackages extends KModelAbstract
{
	/**
	 * Constructor
	 *
	 * @TODO need to find a better filter for internal paths, as using dirname will move up the folder for each request for some odd reason
	 *
	 * @param 	object 	An optional KConfig object with configuration options
	 */
	public function __construct(KConfig $config)
	{
		parent::__construct($config);

		$this->_state
						->insert('folder', 'string', false)
						->insert('file', 'filename', false)
						->insert('directory', 'string', JPATH_COMPONENT_ADMINISTRATOR.'/packages/');
						//->insert('directory', 'dirname', JPATH_COMPONENT_ADMINISTRATOR.'/packages/');
	}

	/**
	 * Get a package
	 *
	 * @return  object
	 */
	public function getItem()
	{
		if(!isset($this->_item))
		{
			$this->_item = $this->_state->file;
			if($this->_state->folder) $this->_item = $this->_state->folder;
		}
	
		return parent::getItem();
	}

	/**
	 * Get packages
	 *
	 * @return  object
	 */
	public function getList()
	{
		if(!isset($this->_list))
		{
			$this->_list  = JFolder::files($this->_state->directory, '^[A-Za-z0-9]', false, false);
			$this->_total = count($this->_list);
		}
		
		return parent::getList();
	}
}