<?php
/**
* @version		$Id: ninja.php 411 2010-08-06 09:41:59Z stian $
* @category		Napi
* @copyright	Copyright (C) 2007 - 2010 NinjaForge. All rights reserved.
* @license		GNU GPLv2 <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
* @link     	http://ninjaforge.com
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.plugin.plugin' );

class plgSystemNinja extends JPlugin
{
	public function __construct($subject, $config)
	{
		parent::__construct($subject, $config);
		
		//If com_ninja don't exist, abort execution to prevent errors
		if(!is_dir(JPATH_ADMINISTRATOR . '/components/com_ninja')) return;
		
		if(!defined('KOOWA') || JFactory::getApplication()->getCfg('dbtype') != 'mysqli' || !function_exists('mysqli_connect'))
		{
			jimport('joomla.filesystem.file');
			if(JFile::exists(JPATH_PLUGINS.'/system/koowa.php'))
			{
				$plugin = (object)array('type' => 'system', 'name' => 'koowa');
				JPluginHelper::_import($plugin, 1, 1);
				
				if(!defined('KOOWA')) return;
			}
			else
			{
				return;
			}
		}
		
		$napiElement = JPATH_ADMINISTRATOR . '/components/com_ninja/elements/joomla.php';
		if(!class_exists('JElementNapi', false) && file_exists($napiElement)) require_once $napiElement;
		
		$app = JFactory::getApplication();
		if($app->isSite()) return;
		
		$path = KFactory::get('admin::com.ninja.helper.application')->getPath('com_xml');
		if(!$path) return;
		
		$xml  = simplexml_load_file($path);
		if(!class_exists('KRequest')) return;
		$name = str_replace('com_', '', KRequest::get('get.option', 'cmd'));
		if(!$xml['mootools']) return;
		if(version_compare($xml['mootools'], '1.2', '<')) return;
		
		JHTML::addIncludePath(JPATH_ROOT.'/administrator/components/com_ninja/html');
		
		
		//Loading Mootools 1.2
		if(class_exists('JHTMLBehavior')) return;
		JHTML::_('behavior.framework');
		
		$command = KFactory::get('admin::com.ninja.command.mootools');
		KFactory::get('lib.koowa.event.dispatcher')->register($command);
		//KFactory::get('admin::com.'.$name.'.dispatcher') 
		//	->getCommandChain()->enqueue($command); 
		
		$document = JFactory::getDocument();
		$config = KFactory::get('lib.joomla.config');
		$debug = $config->getValue('config.debug');
		
		$script = $debug ? '-uncompressed.js' : '.js';
		$script = KRequest::root().'/media/system/js/mootools'.$script;
		KRequest::set('session.application.scripts.mootools', $script, 'string');
	}

	/**
	 * Sets the GET request after route
	 *
	 * This is crucial for SEF mode compatibility.
	 * Unfortunately, when the routing is done, the parsed URI request is set in the $_REQUEST global,
	 * only some of the variables are set in the $_GET global. Important ones like the 'view' variable is not set in $_GET.
	 * 
	 * So in order to fix it, we do the following:
	 * 	1. get and clone the current JURI instance.
	 *	2. Fetch the router from the application instance.
	 *	3. Call the routers parse method on the JURI instance.
	 *	4. Set the result in the $_GET global, without overwriting the existing variables
	 *
	 * @see JApplication::route()
	 * @see JRequest::setVar()
	 * @see KDispatcherDefault::_actionDispatch() 
	 *
	 * @author Stian Didriksen <stian@nooku.org>
	 * @return void
	 */
	public function onAfterRoute()
	{
		if(!defined('KOOWA')) return;

		$uri = clone(JURI::getInstance());

		/**
		 * @TODO figure out how to use KRequest::url
		 * Currently a BadMethodCallException 'Call to undefined method :getPath' from /includes/router.php(50)
		 * is thrown if we try using it.
		 */
		//$uri = KRequest::url();

		$router = KFactory::get('lib.koowa.application')->getRouter();
		$result = $router->parse($uri);

		KRequest::set('get', KHelperArray::merge($result, KRequest::get('get', 'raw')));
	}
}